!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!use this module to transfer the response and covairate observations into lasso subroutine
module datax
 use imsl
 integer, pointer :: nn,pp              
 real*8, pointer :: xx(:,:),yy(:)
end module datax
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
program main
use imsl
integer p,n,tau,ind,q
parameter(n=1,p=5,ind=3)                              ! n is useless in this subroutine and set one here to calcaulate mean and variance (for all n they are the same theoretically); ind: see the remark in the following subroutine 
real*8 pho(p,p),nonc,delta(p),sig(p,p),cl,arl,sdrl,sde,lam,arl0,hl,hu,expe(p),std(p)
parameter(lam=0.2d0,tau=50,arl0=370)                  ! smoothing parameter lambdal; the nomila IC ARL; the change-point tau to calculate steady-state OCARL
40 format(5f15.3)
data pho/1.0,0.1388,0.3496,0.0829,0.2652,0.1388,1.00,0.7324,0.9130,0.6932,0.3496,0.7324,1.00,0.6824,0.8214,0.0829,0.9130,0.6824,1.00,&
0.7640,0.2652,0.6932,0.8214,0.7640,1.00/
!data pho/1.0,0.2629,-0.0912,-0.0704,-0.0432,0.2629,1.0,-0.7201,-0.0667,0.3150,-0.0912,-0.7201,1.0,-0.1895,-0.0051,-0.0704,-0.0667,-0.1895,1.0,-0.3,-0.0432,0.3150,-0.0051,-0.300,1.000/
data delta/0.0,0.0,0.0,0.0,0.0/                       !specify shift pattern 
50 format(1f15.3)  
  !do i=1,p
  ! do j=1,p 
  !     if(i==j) then
  !      pho(i,j)=1.0d0
  !	    else
  !      pho(i,j)=0.75**abs(i-j)
  ! 	endif
  ! enddo
  !enddo
  q=p                                                 !specify q here
   call lasso_com_mu(ind,n,p,pho,expe,std)     !compute the expectation and standard deviation of T_gamma. Run this once that the other parameters are specified. 
   open(unit=1,file='g:\expect1.txt')          !storaged in this default file; if parameter changed, one may change another file to avoid computing them again although it is quite fast to complete this sub.
   write(unit=1,fmt=50)expe
   write(unit=1,fmt=50)std
   close(unit=1) 
  hl=4.0
  hu=5.5
 ! call multi_plr_ic(ind,arl0,lam,p,pho,q,hl,hu,cl)    !use this subroutine to search the control limit; specify a tight upper and lower limits hu and hl to have a quicker convergence
  cl=4.950 ! p=5 the example in Hawkins (1991) arl0=370
  call multi_plrchart(ind,tau,lam,p,pho,q,cl,delta,arl,sdrl,sde)
  write(*,"('ARL='f6.2,x,'SDRL='f6.2,x,'SDE='f6.2,x)")arl,sdrl,sde
 !call mewma(tau,p,pho,delta)
 !call ewmara(tau,p,pho,delta)
end program main
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! search the control limit given arl0,lam and p; the process distribution is assumed normal.
subroutine multi_plr_ic(ind,arl0,lam,p,pho,q,hl,hu,cl)      !!!!!q the specified number of lasso solution involved
use imsl
use datax
integer n,p,i,j,ns,iseed,n1,p1,step,irank,stepmax,kmax,ind,q
parameter(ns=2000,iseed=1235623,stepmax=25,kmax=5000,ns1=10000)
integer df(stepmax)
real*8 y,h,sig1(p,p),id(p,p),x,sig(p,p),rsig(p,p),sol(p,p),sol1(stepmax,p),mu(p),pho(p,p)
real*8 mylamda(8)
real*8 yvec(p),delta1,delta2,delta3,delta4
real*8 yr(p),xtemp(p,p),ytemp(p),sig0(p,p),pbeta1(p)
real*8 err
real*8 bic(0:stepmax),pbeta(p),alpha(p),alphas(p),alpha0,vars(p),ttemp(2*p)
real*8 lam,arl0,epsilon1,epsilon2,hl,hu,cl,r
parameter(epsilon1=2.0d0,epsilon2=0.005)   
target n1
target p1
target xtemp
target ytemp
nn=>n1
pp=>p1
xx=>xtemp
yy=>ytemp
n1=p
p1=p
select case(ind)
  case(1)
   r=0
  case(2)
   r=0.5
  case(3)
   r=1.0
  case(4)
   r=2.0
 end select
40 format(5f15.3)
50 format(1f15.3)
  open(unit=1,file='g:\expect1.txt') 
  read(unit=1,fmt=50)ttemp
  close(unit=1)
   alpha(1:p)=ttemp(1:p)
   alphas(1:p)=ttemp(p+1:2*p)
   sig=.i.pho
  call marsqrt(p,sig,sig1)  
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! search a preliminary control limit using small number of repeats
  sol=0.0d0
  df=0.0d0
  arl=0.0d0
  !hl=4.0
  !hu=5.5
  write(*,40)hl,hu
  arl=0.0d0
  cl=0.0d0
 do while(abs(arl-arl0)>epsilon1.and.abs(cl-(hu+hl)/2.0)>epsilon2)
 cl=(hl+hu)/2.0d0
 arl=0.0d0 
  do ii=1,ns
   call rnset(iseed+ii*2000)
   flag=0
   jj=0
   yr=0.0d0
   do while(flag==0.and.jj<kmax)
    jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
    yr=(1.0d0-lam)*yr+(lam*yvec)
    pbeta1=yr
    ytemp=sig1.x.yr
	do j=1,p
	  xtemp(:,j)=sig1(:,j)*(abs(pbeta1(j)))**r
	enddo
	call lasso(sol1,step,stepmax,df)
	j=p
	do i=step,1,-1
     if(df(i)==j)  then
	   sol(j,:)=sol1(i,:)
	   j=j-1
	 endif
    enddo
     do j=1,p
       sol(:,j)=sol(:,j)*(abs(pbeta1(j)))**r
     enddo
    do j=1,q
     mu=sol(j,:)
     tempmax=(dblinf(p,p,sig,p,mu,yr)**2.0/dblinf(p,p,sig,p,mu,mu))*((2.0-lam)/(lam*(1.0d0-(1.0d0-lam)**(2.0*jj))))
     bic(j)=(tempmax-alpha(j))/alphas(j)
    enddo
     if(maxval(bic(1:q))>cl) flag=1
   enddo
   arl=arl+1.0*jj  
  enddo
  arl=arl/dble(ns)
   if(arl>=arl0) then
    hu=cl
   else
    hl=cl
   endif
   write(*,40)hu,hl,cl,arl    
 enddo
  write(*,"('The raw control limit='f8.3,x)")cl
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! obtain more accurate control limit
  sol=0.0d0
  df=0.0d0
  arl=0.0d0
  hl=cl+0.1
  hu=cl-0.1
  arl=0.0d0
  cl=0.0d0
 do while(abs(arl-arl0)>epsilon1.and.abs(cl-(hu+hl)/2.0)>epsilon2)
 cl=(hl+hu)/2.0d0
 arl=0.0d0 
  do ii=1,ns1
   call rnset(iseed+ii*2000)
   flag=0
   jj=0
   yr=0.0d0
   do while(flag==0.and.jj<kmax)
    jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
    yr=(1.0d0-lam)*yr+(lam*yvec)
    pbeta1=yr

    ytemp=sig1.x.yr
	do j=1,p
	  xtemp(:,j)=sig1(:,j)*(abs(pbeta1(j)))**r
	enddo
	call lasso(sol1,step,stepmax,df)
	j=p
	do i=step,1,-1
     if(df(i)==j)  then
	   sol(j,:)=sol1(i,:)
	   j=j-1
	 endif
    enddo
     do j=1,p
       sol(:,j)=sol(:,j)*(abs(pbeta1(j)))**r
     enddo
    do j=1,q
     mu=sol(j,:)
     tempmax=(dblinf(p,p,sig,p,mu,yr)**2.0/dblinf(p,p,sig,p,mu,mu))*((2.0-lam)/(lam*(1.0d0-(1.0d0-lam)**(2.0*jj))))
     bic(j)=(tempmax-alpha(j))/alphas(j)
    enddo
     if(maxval(bic(1:q))>cl) flag=1
   enddo
   arl=arl+1.0*jj  
  enddo
  arl=arl/dble(ns1)
   if(arl>=arl0) then
    hu=cl
   else
    hl=cl
   endif
   write(*,40)hu,hl,cl,arl
 enddo
   write(*,"('The accurate control limit='f8.3,x)")cl
end subroutine multi_plr_ic
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! the LEWMA chart: compute ARL_0 and ARL_1
subroutine multi_plrchart(ind,tau0,lam,p,pho,q,cl,delta,arl,sdrl,sde)
use imsl
use datax
integer n,p,i,j,ns,iseed,n1,p1,step,irank,stepmax,kmax,tau,ind,tau0,q
parameter(ns=10000,iseed=1235623,stepmax=25,kmax=5000)
integer df(stepmax)
real*8 y,h,sig1(p,p),id(p,p),x,sig(p,p),rsig(p,p),sol(p,p),sol1(stepmax,p),mu(p),pho(p,p)
real*8 yvec(p),delta(p)
real*8 yr(p),xtemp(p,p),ytemp(p),sig0(p,p),pbeta1(p),temp(p),r
real*8 err
real*8 bic(0:stepmax),pbeta(p),alpha(p),alphas(p),alpha0,vars(p),ttemp(2*p)
real*8 lam,arl0,epsilon1,epsilon2,cl,rl(ns),arl,sdrl,sde
target n1
target p1
target xtemp
target ytemp
nn=>n1
pp=>p1
xx=>xtemp
yy=>ytemp
p1=p
n1=p 
 if(sum(abs(delta))<=0.0d0) then
  tau=0                           !!!!!!!!!!!! IC, using zero-state ARL
 else
  tau=tau0                        !!!!!!!!!!!! OC, using steady-state ARL
 endif
 select case(ind)
  case(1)
   r=0
  case(2)
   r=0.5
  case(3)
   r=1.0
  case(4)
   r=2.0
 end select
  40 format(5f15.3)
  50 format(1f15.3)
  open(unit=1,file='g:\expect1.txt') 
  read(unit=1,fmt=50)ttemp
  close(unit=1)
  alpha(1:p)=ttemp(1:p)
  alphas(1:p)=ttemp(p+1:2*p)
  sig=.i.pho
  call marsqrt(p,sig,sig1)  
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  sol=0.0d0
  df=0.0d0
  arl=0.0d0
  arl1=0.0d0
  nns=0
  do ii=1,ns
   call rnset(iseed+ii*2000)
   flag=0
   jj=0
   yr=0.0d0
      
   do while(jj<kmax.and.flag==0)
   jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
	if(jj>tau)	yvec=yvec+delta
    yr=(1.0d0-lam)*yr+(lam*yvec)
    pbeta1=yr
    
    ytemp=sig1.x.yr
	do j=1,p
	  xtemp(:,j)=sig1(:,j)*(abs(pbeta1(j)))**r
	enddo
   call lasso(sol1,step,stepmax,df)
	j=p
	do i=step,1,-1
     if(df(i)==j)  then
	   sol(j,:)=sol1(i,:)
	   j=j-1
	 endif
    enddo
      do j=1,p
       sol(:,j)=sol(:,j)*(abs(pbeta1(j)))**r
      enddo
    do j=1,q
     mu=sol(j,:)
     tempmax=(dblinf(p,p,sig,p,mu,yr)**2.0/dblinf(p,p,sig,p,mu,mu))*(2.0-lam)/lam
     bic(j)=(tempmax-alpha(j))/alphas(j)
    enddo
    if(maxval(bic(1:q))>cl)  flag=1
   enddo
   if(jj>tau) then
    nns=nns+1
    rl(nns)=jj*1.0
    if(mod(nns,1000)==0) write(*,40)1.0*nns,sum(rl(1:nns))/dble(nns)
   endif
  enddo   
   rl=rl-tau
   arl=sum(rl(1:nns))/dble(nns)
   sdrl=(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns))**0.5)
   sde=(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns))**0.5)/dble(ns)**0.5
end subroutine multi_plrchart
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! MEWMA Chart
subroutine mewma(tau,p,pho,delta)
use imsl
use datax
integer n,p,i,j,ns,iseed,n1,p1,flag,flagg(6),tauest,tau
parameter(ns=10000,iseed=1235623,kmax=5000)
real*8 h,sig1(p,p),sig(p,p),rsig(p,p),pho(p,p)
real*8 yvec(p),ew(p),ew1(0:kmax,p),ew2(p)
real*8 yr(p),temp1(ns,6),temp2(ns,6),t2,delta(p),aa1,bb1,aa2,bb2
real*8 lam,rl(ns),tempy,tauarr(ns),temp(p)
parameter(lam=0.2)
target p1
pp=>p1
p1=p 
  !h=15.74*(lam)/(2.0-lam)
  !h=34.75*(lam)/(2.0-lam) !lam=0.2 arl=500 p=15
  h=18.13*(lam)/(2.0-lam)
  alpha0=0.05
  40 format(5f15.3)
  30 format(7f10.2)
  temp1=0.0d0
  temp2=0.0d0
  sig=.i.pho 
  aa1=0.0d0
  bb1=0.0d0
  aa2=0.0d0
  bb2=0.0d0
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  nns=0
  tauarr=0.0d0
  rl=0.0d0
  do ii=1,ns
   call rnset(iseed+ii*2000)
   flag=0
   ew=0.0d0
   jj=0
   do while(jj<kmax.and.flag==0)
    jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
	if(jj>tau) yvec=yvec+delta
    ew=(1.0d0-lam)*ew+lam*yvec
	t2=dblinf(p,p,sig,p,ew,ew)  
	if(t2>h) flag=1
   enddo
   if(jj>tau) then
    nns=nns+1
    rl(nns)=jj*1.0-tau
   endif
  enddo
 write(*,40)1.0*nns,sum(rl(1:nns))/dble(nns),(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns-1))**0.5)/nns**0.5
endsubroutine mewma
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! REWMA Chart
subroutine ewmara(tau,p,pho,delta)
use imsl
use datax
integer n,p,i,j,ns,iseed,n1,p1,flag,flagg(6),tau
parameter(ns=50000,iseed=1235623,kmax=5000)
real*8 h,sig1(p,p),sig(p,p),rsig(p,p),pho(p,p),ra(p),id(p,p),dlarr(p,p)
real*8 yvec(p),ew(p)
real*8 yr(p),temp(p),t2,delta(p)
real*8 lam,rl(ns)
parameter(lam=0.2)
target p1
pp=>p1
p1=p 
 h=3.425*((lam)/(2.0-lam))**0.5 !lam=0.2 arl=500 p=15
  alpha0=0.05
  40 format(5f15.3)
  50 format(1f15.3)
  id=0.0d0
  sig=.i.pho 
  rl=0.0d0
  do i=1,p
   do j=1,p 
    if(i==j) id(i,j)=1.0d0
   enddo
  enddo
  nns=0
  do i=1,p
   do j=1,p
     dlarr(i,j)=sig(i,j)/dblinf(p,p,sig,p,id(i,:),id(i,:))**0.5  
   enddo
  enddo

  call marsqrt(p,sig,sig1)  
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  do ii=1,ns
   call rnset(iseed+ii*2000)
   flag=0
   ew=0.0d0
   jj=0
   do while(jj<kmax.and.flag==0)
    jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
	if(jj>tau)	yvec=yvec+delta
    ew=(1.0d0-lam)*ew+lam*yvec
    ra=dlarr.x.ew  
	if(maxval(abs(ra))>h) flag=1
   enddo
   if(jj>tau) then
    nns=nns+1
    rl(nns)=jj*1.0-tau
   endif
  enddo
 write(*,40)1.0*nns,sum(rl(1:nns))/dble(nns),(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns-1))**0.5)/nns**0.5
endsubroutine ewmara
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! matrix_power1/2
subroutine marsqrt(p,a,a2) 
use imsl
integer i,p
real*8 a(p,p),eig2(p),a1(p,p),eig1(p),u(p,p),a2(p,p)
 call lin_eig_self(a,eig2,v=a1)
 u=0.0d0
 do i=1,p
  eig1(i)=eig2(i)**0.5
  u(i,i)=eig1(i)
 enddo
 a2=a1.x.u.x.(.t.a1)
end subroutine marsqrt
