!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module datax
use imsl
integer, pointer :: nn,pp
real*8, pointer :: xx(:,:),yy(:)
end module datax
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
program main
use imsl
implicit none
integer p,n,tau,ind,q
parameter(n=1,p=5,ind=3)
real*8 pho(p,p),nonc,delta(p),sig(p,p),cl,lam,arl,sdrl,sde,diagr(4),expe(p),std(p)
parameter(lam=0.2)
40 format(5f15.3)
50 format(1f15.3)  
data pho/1.0,0.1388,0.3496,0.0829,0.2652,0.1388,1.00,0.7324,0.9130,0.6932,0.3496,0.7324,1.00,0.6824,0.8214,0.0829,0.9130,0.6824,1.00,0.7640,0.2652,0.6932,0.8214,0.7640,1.00/
data delta/1.0,0.0,0.5,0.0,0.0/  
!write(*,40)pho
 !! do i=1,p
 !  do j=1,p 
 !   if(i==j) then
! 	 pho(i,j)=1.0d0
! 	else
! 	 pho(i,j)=0.75**abs(i-j)
! 	endif
!   enddo
!  enddo
 q=p
   call lasso_com_mu(ind,n,p,pho,expe,std)     !compute the expectation and standard deviation of T_gamma. Run this once that the other parameters are specified. 
   open(unit=1,file='g:\expect1.txt')          !storaged in this default file; if parameter changed, one may change another file to avoid computing them again although it is quite fast to complete this sub.
   write(unit=1,fmt=50)expe
   write(unit=1,fmt=50)std
   close(unit=1) 

  tau=25
  cl=5.268
  call lasso_chart_diag(ind,tau,lam,p,pho,q,cl,delta,arl,sdrl,sde,diagr)
  write(*,"('ARL='f6.2,x,'SDRL='f6.2,x,'SDE='f6.2,x)")arl,sdrl,sde
  write(*,"('r1='f7.3,x,'r2='f7.3,x,'r3='f7.3,x,'r4='f7.3,x)")diagr(1),diagr(2),diagr(3),diagr(4)
end program main
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! monitoring and diagnosis 2 in 1
subroutine lasso_chart_diag(ind,tau0,lam,p,pho,q,cl,delta,arl,sdrl,sde,diagresult)
use imsl
use datax
integer n,p,i,j,ns,iseed,zeta,zeta1,zeta2,zeta3,zeta4,n1,p1,step,irank,stepmax,kmax,tau0,tauest,flagg(6),ind,q
parameter(ns=10000,iseed=1235623,stepmax=25,kmax=5000)
integer df(stepmax)
real*8 y,h,sig1(p,p),id(p,p),x,sig(p,p),rsig(p,p),sol(p,p),sol1(stepmax,p),mu(p),pho(p,p)
real*8 yvec(p),delta(p)
real*8 yr(p),xtemp(p,p),ytemp(p),sig0(p,p),pbeta1(p),temp(p)
real*8 err
real*8 bic(0:stepmax),pbeta(p),alpha(p),alphas(p),alpha0,vars(p),ttemp(2*p),bica(p),diagresult(4)
real*8 lam,arl0,epsilon1,epsilon2,hl,hu,cl,rl(ns),arl,sdrl,sde,r
real*8 tempmax,ew1(0:kmax,p),ew2(p),tempy,temp2(ns,6)   
target n1
target p1
target xtemp
target ytemp
nn=>n1
pp=>p1
xx=>xtemp
yy=>ytemp
p1=p
n1=p 
 if(sum(abs(delta))<=0.0d0) then
  tau=0                           !!!!!!!!!!!! IC, using zero-state ARL
 else
  tau=tau0                        !!!!!!!!!!!! OC, using steady-state ARL
 endif
 select case(ind)
  case(1)
   r=0
  case(2)
   r=0.5
  case(3)
   r=1.0
  case(4)
   r=2.0
 end select
  40 format(5f15.3)
  50 format(1f15.3)
  open(unit=1,file='g:\expect1.txt') 
  read(unit=1,fmt=50)ttemp
  close(unit=1)
  alpha(1:p)=ttemp(1:p)
  alphas(1:p)=ttemp(p+1:2*p)
  sig=.i.pho
  call marsqrt(p,sig,sig1)  
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  sol=0.0d0
  df=0.0d0
  arl=0.0d0
  arl1=0.0d0
  nns=0
  do ii=1,ns
   call rnset(iseed+ii*2000)
   flag=0
   jj=0
   yr=0.0d0
   tempmax=0.0d0
   do while(jj<kmax.and.flag==0)
    jj=jj+1
	call drnmvn(1,p,rsig,p,yvec,1)
	if(jj>tau)	yvec=yvec+delta
    yr=(1.0d0-lam)*yr+(lam*yvec)
    pbeta1=yr
    ytemp=sig1.x.yr
	do j=1,p
	 xtemp(:,j)=sig1(:,j)*(abs(pbeta1(j))**r)
	enddo
   call lasso(sol1,step,stepmax,df)
	j=p
	do i=step,1,-1
     if(df(i)==j)  then
	   sol(j,:)=sol1(i,:)
	   j=j-1
	 endif
    enddo
      do j=1,p
       sol(:,j)=sol(:,j)*(abs(pbeta1(j))**r)
      enddo
    do j=1,q
     mu=sol(j,:)
     tempmax=(dblinf(p,p,sig,p,mu,yr)**2.0/dblinf(p,p,sig,p,mu,mu))*(2.0-lam)/lam
     bic(j)=(tempmax-alpha(j))/alphas(j)
    enddo
   if(maxval(bic(1:q))>cl) flag=1
   enddo
   if(jj>tau) then
    nns=nns+1
    rl(nns)=jj*1.0
!	if(mod(ii,1000)==0) write(*,40)1.0*ii,sum(rl(1:nns))/dble(nns)
     do j=1,p
      mu=sol(j,:)
	  bica(j)=1.0*(2.0-lam)/lam*dblinf(p,p,sig,p,yr-mu,yr-mu)+2.0*log(1.0d0*p)*j
     enddo
     mu=sol(minloc(bica(1:p),dim=1),:)
     k0=0
     do j=1,p
      if(delta(j)==0.0) k0=k0+1
	 enddo   
	 flagg=0
     j=0
   	do while(j<p)
	 j=j+1
     if(delta(j)==0.0.and.mu(j)/=0.0) flagg(5)=flagg(5)+1     
	 if(delta(j)/=0.0.and.mu(j)==0.0) flagg(6)=flagg(6)+1
    enddo 
	if(flagg(5)==0.and.flagg(6)==0) flagg(1)=1
    if(flagg(5)==k0.and.flagg(6)==p-k0) flagg(2)=1
    if(flagg(5)==0.and.flagg(6)/=0.0) flagg(3)=1
    if(flagg(6)==0.and.flagg(5)/=0.0)   flagg(4)=1
    temp2(nns,:)=temp2(nns,:)+1.0*flagg
   endif
  enddo   
   rl=rl-tau
   arl=sum(rl(1:nns))/dble(nns)
   sdrl=(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns))**0.5)
   sde=(((sum(rl(1:nns)*rl(1:nns))-1.0*nns*(sum(rl(1:nns))/dble(nns))**2.0)/dble(nns))**0.5)/dble(ns)**0.5
   cc=sum(temp2(:,1))/dble(nns)+sum(temp2(:,3))/dble(nns)+sum(temp2(:,4))/dble(nns)
   diagresult(1)=sum(temp2(:,1))/dble(nns)
   diagresult(2)=sum(temp2(:,3))/dble(nns)
   diagresult(3)=sum(temp2(:,4))/dble(nns)
   diagresult(4)=1.0-cc
end subroutine lasso_chart_diag
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! matrix_power1/2
subroutine marsqrt(p,a,a2) 
use imsl
integer i,p
real*8 a(p,p),eig2(p),a1(p,p),eig1(p),u(p,p),a2(p,p)
 call lin_eig_self(a,eig2,v=a1)
 u=0.0d0
 do i=1,p
  eig1(i)=eig2(i)**0.5
  u(i,i)=eig1(i)
 enddo
 a2=a1.x.u.x.(.t.a1)
end subroutine marsqrt
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


